using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Sanford.Multimedia.Midi;

namespace ProgramListDemo
{
    public partial class Form1 : Form
    {
        private Sanford.Multimedia.Midi.OutputDevice outDevice = null;

        private Sanford.Multimedia.Midi.ChannelMessageBuilder builder = new ChannelMessageBuilder();
            
        public Form1()
        {
            builder.Command = ChannelCommand.ProgramChange;
            builder.MidiChannel = 0;

            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            if(OutputDevice.DeviceCount == 0)
            {
                MessageBox.Show("No MIDI output devices available.", "Error!",
                    MessageBoxButtons.OK, MessageBoxIcon.Stop);

                Close();
            }
            else
            {
                try
                {
                    outDevice = new OutputDevice(0);
                }
                catch(Exception ex)
                {
                    MessageBox.Show(ex.Message, "Error!",
                        MessageBoxButtons.OK, MessageBoxIcon.Stop);

                    Close();
                }
            }

            base.OnLoad(e);
        }

        protected override void OnClosed(EventArgs e)
        {
            if(outDevice != null)
            {
                outDevice.Dispose();
            }

            base.OnClosed(e);
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {           
            if(outDevice != null)
            {
                builder.Data1 = comboBox1.SelectedIndex;

                builder.Build();

                outDevice.Send(builder.Result);
            }

        }
    }
}